#include <assert.h>
#include "vec3.h"       //"" perché cerca nella cartella locale, mentre <> sono quelle di sistema
#include "picture.h"
#include "raycasting.h"
#include "scene.h"

void unit_test_dot_cross() { //test correttezza dot e cross
    Vec3 a(1, 4, 7);
    Vec3 b(9, 6, 5);

    Vec3 c = cross(a, b);
    Vec3 d = cross(b, a);
    c.printf();
    
    assert(c == -d);
    assert(dot(a,c) == 0);
    assert(dot(b,c) == 0);
}

void unit_test_angles() {
    Vec3 a(1, 4, 7);
    Vec3 b(9, 6, 5);

    Vec3 c = cross(a, b);

    assert(degrees_between(a, c) == 90);
    assert(are_equal(degrees_between(a, c), 90));
}

Scene s;


int main() {
    //Picture pic(80,80);
    //pic.fill_with_checkerboard();
    s.populate();
    Picture pic = render(60, s);
    pic.print_to_screen();
    pic.save_as_pnm("image.pnm");
    unit_test_dot_cross();
    unit_test_angles();
}


//TODO: interpolation