#include <iostream>
#include <fstream>
#include "picture.h"

Picture::Picture(int x, int y): res_x(x), res_y(y) { //inizializzo perchè const in picture.h
    pixels.resize(x*y); //buffer linearizzato di pixel (non matrice)
}
char to_char (Pixel x){
    Scalar grey_scale = x.length();
    switch (int(grey_scale*10)) {
        case 0: return ' ';
        case 1: return '.';
        case 2: return ',';  
        case 3: return ':';
        case 4: return ';';
        case 5: return '/';
        case 6: return '|';
        case 7: return '#';
        case 8: return '#';
        case 9: return '#';
        default: return '#';
    }
    //return '#'; //valore ascii di #
}

void Picture::fill_with_checkerboard() { //funzione dentro il metodo
    Pixel colA(0,0,0); //rosso, verde, blu
    Pixel colB(0, 1, 0);
    for (int y = 0; y < res_y; y++)
    for (int x = 0; x < res_x; x++) {
        pixel(x, y) = ((x/10 + y/10) % 2 == 0) ? colB : colA; //costrutto ternario o condizionale;  y*res_x+x "linearizza" l'immagine
        //left value = che permette l'assegnazione/si può mettere a sx
    }
}

void Picture::print_to_screen()const {
    for (int y = 0; y < res_y; y++) {
        for (int x = 0; x < res_x; x++) {
            std::cout << to_char(pixel(x, y)) << ' ';
        }
        std::cout << std::endl;
    }
}

void Picture::save_as_pnm(const std::string &filename)const {
    std::ofstream file(filename);
    file << "P3" << std::endl << res_x << ' ' << res_y << std::endl << 255 << std::endl; //header
    for (int y = 0; y < res_y; y++) { //per tutti i pixel...
        for (int x = 0; x < res_x; x++) { //posizione x del pixel, x dentro perchè cicla "->->" anzichè in verticale, più efficente perchè accede alla "memoria vicina"
            Pixel p = pixel(x, y);
            file << int(p.x*255) << ' ';
            file << int(p.y*255) << ' ';
            file << int(p.z*255) << ' ';
        }
        file << std::endl;
    }
    file.close();
}