#pragma once
#include <vector>
#include <string>
#include "vec3.h"


typedef Vec3 Pixel; //Pixel->sinonimo di Vec3
class Picture
{
public:
    std::vector<Pixel> pixels;
    const int res_x, res_y;

    Picture(int x, int y);

    void fill_with_checkerboard();
    void print_to_screen()const;
    void save_as_pnm(const std::string &filename)const; //const finale->l'immagine rimane invariata se salvata come pnm

    Pixel& pixel(int x, int y){ //restituisce la posizione in memoria del pixel
        return pixels[y*res_x+x];
    }

    Pixel pixel(int x, int y) const { //OVERLOADING (per il print_to_screen), per quando serve leggere il pixel senza cambiarlo
        return pixels[y*res_x+x];
    }

    
};
